package passport

import (
	"golib.gaore.com/GaoreGo/gaore-common-sdk-go/sdk"
	"golib.gaore.com/GaoreGo/gaore-common-sdk-go/sdk/requests"
	"strings"
)

const (
	VERSION = "2025-05-28"
	// 对称加密密钥
	appKey = "#gr*%com#"
)

var HOST requests.Host = requests.Host{
	Default: "passport.gaore.com",
}

type Client struct {
	sdk.Client
}

func NewClient() (client *Client, err error) {
	client = new(Client)
	err = client.Init()
	return
}

// GetUserList
// 获取用户列表
func (c *Client) GetUserList(req *GetUserListRequest) (response *GetUserListResponse, err error) {
	response = CreateGetUserListResponse()
	err = c.DoAction(req, response)
	return
}

// GetUserRoleList
// 获取用户角色列表
func (c *Client) GetUserRoleList(req *GetUserRoleListRequest) (response *GetUserRoleListResponse, err error) {
	response = CreateGetUserRoleListResponse()
	err = c.DoAction(req, response)
	return
}

// EditCard
// 新增或修改实名信息
func (c *Client) EditCard(req EditCardRequestParam) (response string, err error) {
	editCardRequest := CreateEditCardRequest(req)
	createEditCardResponse := CreateEditCardResponse()
	err = c.DoAction(editCardRequest, createEditCardResponse)
	if err != nil && strings.Contains(err.Error(), "json Unmarshal:") {
		return createEditCardResponse.GetHttpContentString(), nil
	} else if err != nil {
		return "", err
	}
	return createEditCardResponse.GetHttpContentString(), nil
}
